#include <gtk/gtk.h>
#include <stdio.h>
#include <stdlib.h>
#include <X11/xpm.h>

typedef struct {
	int border;
	int angle;
	int sticky;
	int ontop;
	char alarm[128];
	int transparent;
	int desktopBackgd;
	int shade;
	int paddingX;
	int paddingY;
	char fontName[128];
	char textColor[16];
	char backgdColor[1024];
	char title[1024];
	char text[1024];
} NoteStruct;

void loop(void);
void load_config(char*);
void initialize(int,char**);
void create_note(void);
void delete_note(void);
int timer_function(int,struct timeval*);
void query_config(char*,char*,char*);
int save_config();
void my_system(char*);
void usage();

//ALL FUNCTIONS for CONFIG WINDOW
typedef struct {
	GtkWidget *border_cb;
	GtkWidget *sticky_cb;
	GtkWidget *ontop_cb;
	GtkWidget *angle_sc;
	GtkWidget *alarm_tf;
	GtkWidget *transparent_cb;
	GtkWidget *desktopbg_cb;
	GtkWidget *shade_sc;
	GtkWidget *backgd_tf; //backgd color or file text field
	GtkWidget *textColor_tf; //text color text field
	GtkWidget *font_label; //fontname label
	GtkWidget *xPadding_combo;
	GtkWidget *yPadding_combo;
	GtkWidget *text; //text
	GtkWidget *title_tf; //title text field
} CONFIG_WINDOW;


void initialize_config_window();
GtkWidget* create_fancy_panel();
GtkWidget* create_backgd_panel();
GtkWidget* create_text_panel();
gint timer_func(gpointer);
void hide_config(void);
void Display_Config();
void Set_Config_Fields();
void flush_data(void);
//backgd
void select_backgdFile_ok(GtkWidget*,GtkFileSelection*);
void backgdFiles_b_pressed(GtkWidget*,GdkEvent*,gpointer);
void backgdColor_b_pressed(GtkWidget*);
void backgdColor_changed(GtkColorSelection*);
void finished_with_backgdColor_cb(GtkWidget*,GtkColorSelection*);
//text
void textColor_b_pressed(GtkWidget*);
void textColor_changed(GtkColorSelection*);
void select_font_ok(GtkWidget*,GtkFontSelectionDialog*);
void font_b_pressed(GtkWidget*,GdkEvent*,gpointer);
void finished_with_textColor_cb(GtkWidget*,GtkColorSelection*);
