//for X functions...
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
//for printf...
#include <stdio.h>
#include <stdlib.h>
//imlib stuff
#include <Imlib.h>

//#define DEBUG

#ifndef NOTES_H
#define NOTES_H 1
class CNotes {

private:
	//functions
	void convert_rgb_to_pixel(int,int,int,unsigned long*);
	Pixmap Setup_DesktopBackgd();
	Pixmap Setup_Background();
	Pixmap Setup_Text();
	Pixmap Paste_Text(Pixmap,ImlibImage*);
	int Blur_Color(int,int,int,int,int,int,int,int,int);
	void Setup_Note_Size();
	void Setup_Layer(int);
	void Setup_Sticky(int);
	void Setup_Border(int);

	//variables
	int border;
	int sticky;
	int ontop;
	double angle;
	int note_width;
	int note_height;
	int note_x;
	int note_y;
	int transparent;
	int shade;
	int desktopBackgd;
	int xPadding;
	int yPadding;
	char alarm[128];
	char backgdColor[1024];
	char textColor[16];
	char title[1024];
	char fontName[1024];
	char text[1024];

	//variables for graphic manipulations
	ImlibData *id;
	Colormap cmap;
	Window note_win;
	Pixmap note_pixmap;
	Font font;
	int char_height;
	int char_asc;
	int move_flag;

public:
	CNotes();
	~CNotes();
	//SET
	void Set_Border(int);
	void Set_Sticky(int);
	void Set_Ontop(int);
	void Set_Angle(int);
	void Set_Alarm(char*);
	void Set_DesktopBackgd(int);
	void Set_BackgdColor(char*);
	void Set_TextColor(char*);
	void Set_Font(char*);
	void Set_Title(char*);
	void Set_Text(char*);
	void Set_FontName(char*);
	void Set_Transparent(int);
	void Set_Shade(int);
	void Set_XPadding(int);
	void Set_YPadding(int);
	void Set_Position(int,int);
	//GET
	Display *Get_Display() const;
	int Get_Border() const;
	int Get_Sticky() const;
	int Get_Ontop() const;
	int Get_Angle() const;
	int Get_DesktopBackgd() const;
	int Get_Transparent() const;
	int Get_Shade() const;
	int Get_Width() const;
	int Get_Height() const;
	int Get_XPadding() const;
	int Get_YPadding() const;
	const char* Get_Alarm() const;
	const char* Get_BackgdColor() const;
	const char* Get_TextColor() const;
	const char* Get_FontName() const;
	const char* Get_Title() const;
	const char* Get_Text() const;
    const char* Get_XMLText() const;
	//VARIOUS
	void Build_Note();
	void Refresh_Note(int,int,int,int);
	void Watch_Window_Move();
};
#endif
