#include    <sax2/DefaultHandler.hpp>
#include    <framework/XMLFormatter.hpp>

class SAX2Handlers : public XERCES_CPP_NAMESPACE_QUALIFIER DefaultHandler, private XERCES_CPP_NAMESPACE_QUALIFIER XMLFormatTarget
{
public:

    // -----------------------------------------------------------------------
    //  Constructors
    // -----------------------------------------------------------------------
    SAX2Handlers
    (
        const   char* const                 encodingName
        , const XERCES_CPP_NAMESPACE_QUALIFIER XMLFormatter::UnRepFlags    unRepFlags
		, const bool						expandNamespaces
    );
    ~SAX2Handlers();


    // -----------------------------------------------------------------------
    //  Implementations of the format target interface
    // -----------------------------------------------------------------------
    void writeChars
    (
        const   XMLByte* const  toWrite
    );

    void writeChars
    (
        const   XMLByte* const  toWrite
        , const unsigned int    count
        , XERCES_CPP_NAMESPACE_QUALIFIER XMLFormatter* const   formatter
    );


    // -----------------------------------------------------------------------
    //  Implementations of the SAX DocumentHandler interface
    // -----------------------------------------------------------------------
    void endDocument();

    void endElement( const XMLCh* const uri, 
					 const XMLCh* const localname, 
					 const XMLCh* const qname);

    void characters(const XMLCh* const chars, const unsigned int length);

    void ignorableWhitespace
    (
        const   XMLCh* const    chars
        , const unsigned int    length
    );

    void processingInstruction
    (
        const   XMLCh* const    target
        , const XMLCh* const    data
    );

    void startDocument();

    void startElement(	const    XMLCh* const    uri,
						const    XMLCh* const    localname,
						const    XMLCh* const    qname,
					    const   XERCES_CPP_NAMESPACE_QUALIFIER Attributes&		attributes);



    // -----------------------------------------------------------------------
    //  Implementations of the SAX ErrorHandler interface
    // -----------------------------------------------------------------------
    void warning(const XERCES_CPP_NAMESPACE_QUALIFIER SAXParseException& exception);
    void error(const XERCES_CPP_NAMESPACE_QUALIFIER  SAXParseException& exception);
    void fatalError(const XERCES_CPP_NAMESPACE_QUALIFIER  SAXParseException& exception);



    // -----------------------------------------------------------------------
    //  Implementation of the SAX DTDHandler interface
    // -----------------------------------------------------------------------
    void notationDecl
    (
        const    XMLCh* const    name
        , const  XMLCh* const    publicId
        , const  XMLCh* const    systemId
    );

    void unparsedEntityDecl
    (
        const    XMLCh* const    name
        , const  XMLCh* const    publicId
        , const  XMLCh* const    systemId
        , const  XMLCh* const    notationName
    );

	void getNote(NoteStruct *n);
	void setNote(NoteStruct *n);
	void getNotesList(LinkedList **nl);
	void getDefaultNote(NoteStruct **n);
	void setNotesList(LinkedList *nl);

private :


    // -----------------------------------------------------------------------
    //  Private data members
    //
    //  fFormatter
    //      This is the formatter object that is used to output the data
    //      to the target. It is set up to format to the standard output
    //      stream.
    // -----------------------------------------------------------------------
    XERCES_CPP_NAMESPACE_QUALIFIER XMLFormatter    fFormatter;
	bool			fExpandNS ;
};
