#include <string>
#include "wmEnotes.h"
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>
/*
	This code has been inspired from wmppp for the control and the dockapp.

	Author: Philippe Vigneron (vigneron@free.fr)

	This program is distributed under the GPL license.

	Changes:
	05/10/2001
		*this program has been mostly rewritten to support docking
		 and xml format to store the notes (need Xerces library).
		*time clock on the dock app.
		*total number of notes on the dock app.
		*error leds if notes cannot be read or saved.
		*no more use of C++ linked lists, wmlist is used instead.
		*the configuration window is now dissociated from the main program.
		*dock app redesign, inspired from wmppp.
		*no more epplet compatibility, will come next I think.
		*removed alarm clock.
		*the notes are save automatically.
		
*/

int wmEnotes_mask_width = 64;
int wmEnotes_mask_height = 64;
char wmEnotes_mask_bits[64*64];
char	*ProgName, *config_program="wmEnotesConfig", *notes_file="~/.wmEnotesNotes", *notes_temp_file="~/.wmEnotesTemp";
static LinkedList		*notes;
CNotesConfig *conf;
time_t config_time=0;
CNotes *note_to_configure;
bool queryRightClick;
bool backupConfig;

int main(int argc, char *argv[]) {

	int i;
    queryRightClick = false;
    backupConfig = false;
      /* Parse Command Line */

	ProgName = argv[0];
	if (strlen(ProgName) >= 5) ProgName += (strlen(ProgName) - 5);
	
	for (i=1; i<argc; i++) {
		char *arg = argv[i];

		if (*arg=='-') {
			switch (arg[1]) {
			case 'c' :
				if (strcmp(arg+1, "config")) {
					usage();
					exit(1);
				}
				i++;
				if (!argv[i]) {
					usage();
					exit(1);
				}
				config_program = argv[i];
				break;
			case 'n' :
				if (strcmp(arg+1, "notes")) {
					usage();
					exit(1);
				}
				i++;
				if (!argv[i]) {
					usage();
					exit(1);
				}
				notes_file = argv[i];
				break;
			case 't' :
				if (strcmp(arg+1, "temp")) {
					usage();
					exit(1);
				}
				i++;
				if (!argv[i]) {
					usage();
					exit(1);
				}
				notes_temp_file = argv[i];
				break;
			case 'v' :
				printversion();
				exit(0);
				break;
            case 'q' :
               queryRightClick = true;
               break;
            case 'b' :
               backupConfig = true;
               break;
               
            default:
				usage();
				exit(0);
				break;
			}
		}
	}

	wmEnotes_routine(argc, argv);

	return 0;
}

void wmEnotes_routine(int argc, char **argv) {

	/* Open the display */

	createXBMfromXPM(wmEnotes_mask_bits, wmEnotes_mask_xpm, wmEnotes_mask_width, wmEnotes_mask_height);

	openXwindow(argc, argv, wmEnotes_mask_xpm, wmEnotes_mask_bits, wmEnotes_mask_width, wmEnotes_mask_height);

	/* New Button */
	AddMouseRegion(0, 35, 48, 46, 58);
	/* x Button */
	AddMouseRegion(1, 47, 48, 58, 58);

	//copyXPMArea(28, 95, 25, 11, 5, 48);

	/* Initialize some stuff */
	//TODO initialization HERE
	conf = new CNotesConfig();
	read_config_file();
	DrawNumberOfNotes(list_length(notes));

/* wmEnotes main loop */
	while (1) {
		main_loop();
		notes_loop();
		//sleep a little bit...
		usleep(50000L);
		}
	}

void main_loop(void) {
int				i;
static int				but_stat=-1;
XEvent			Event;
struct stat buf;
struct tm *current_time;
time_t current_seconds;

	time(&current_seconds);
	current_time = localtime(&current_seconds);

	stat(notes_temp_file,&buf);
	if (config_time!=0 && config_time != buf.st_mtime) {
		config_time = buf.st_mtime;
		if (note_to_configure!=NULL) {
			read_temp_config_file();
			printf("file has been modified...\n");
			}
		else {
			read_temp_default_config_file();
			printf("default note file has been modified...\n");
			}
		}

	while (XPending(display)) {
		XNextEvent(display, &Event);
		switch (Event.type) {
		case Expose:
			RedrawWindow();
			break;
		case DestroyNotify:
			XCloseDisplay(display);
			write_config_file();
			exit(0);
			break;
		case ButtonPress:
			i = CheckMouseRegion(Event.xbutton.x, Event.xbutton.y);
			switch (i) {
			case 0:
				ButtonDown(NEW_BUTTON);
				break;
			case 1:
				ButtonDown(BUT_X);
				break;
			}
			but_stat = i;

			break;
		case ButtonRelease:
			i = CheckMouseRegion(Event.xbutton.x, Event.xbutton.y);
			switch (but_stat) {
			case 0:
				create_note();
				DrawNumberOfNotes(list_length(notes));
				ButtonUp(NEW_BUTTON);
				write_config_file();
				break;
			case 1:
				note_to_configure=NULL;
				open_default_config_window();
				ButtonUp(BUT_X);
			break;
			}

			if (i == but_stat && but_stat >= 0) {
				switch (i) {
				case 0:
					//if (!starttime) {
					//	copyXPMArea(28, 95, 25, 11, 5, 48);
//							DrawTime(0, 1);
//							start_child = execCommand(start_action);
//							SetWaitLED(LED_PPP_POWER);
					//}

					break;
				case 1:
//						if (stop_child == 0) {
//							stop_child = execCommand(stop_action);
//						}
					break;
				}
			}
			RedrawWindow();
				
			but_stat = -1;
			break;
		default:
			break;
		}
	}
    DrawClock(current_time->tm_hour,current_time->tm_min,current_time->tm_sec);

}

int desliga() {
      // they meant it!
    return 1;
}

// check the user intended to delete the note
bool userAccident()
{
#if 0
	GtkWidget *label;
	GtkWidget *dialog;
	gchar *message;
	GtkWidget *ok_button;
	GtkWidget *cancel_button;

    message = "Delete confirmation";
    dialog = gtk_dialog_new();
    label = gtk_label_new (message);
	    
    ok_button = gtk_button_new_with_label("OK");
    cancel_button = gtk_button_new_with_label("Cancel");
    gtk_signal_connect_object (GTK_OBJECT (cancel_button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy),  (GtkObject*) dialog);
 
    gtk_signal_connect_object (GTK_OBJECT (ok_button), "clicked", GTK_SIGNAL_FUNC (desliga),  (GtkObject*) dialog);
		
#endif
   return true;
}

//taking care of refreshing the notes.........................
void notes_loop(void) {
XEvent			Event;
CNotes			*note;
LinkedList *list;
int out = 0;

	for (list=notes;list;list=list->tail) {
		note = (CNotes*)list->head;
		//check if root win backgd update needed
		if (note->Get_DesktopBackgd() && !note->Get_Transparent()) note->Watch_Window_Move();
	
		while (XPending(note->Get_Display())) {
			XNextEvent(note->Get_Display(), &Event);
			switch (Event.type) {
				case Expose:
					note->Refresh_Note(Event.xexpose.x, Event.xexpose.y, Event.xexpose.width, Event.xexpose.height);
					break;
				case ButtonPress:
					//create the configuration window...
					if (Event.xbutton.button==1) {
						note_to_configure = note;
						open_config_window(note);
						}
					if (Event.xbutton.button==3) {
                       if (queryRightClick)
                          if (userAccident()) continue;
                       if (note==note_to_configure) config_time = 0;
						delete note;
						notes = list_remove_elem(notes,note);
						DrawNumberOfNotes(list_length(notes));
						write_config_file();
						out = 1;
						}
					break;
				}
			}
		if (out==1) break;
		}

	}

void read_config_file() {
    CNotes *note;
    LinkedList *noteConfigList,*list;
    NoteStruct *n;

    if (backupConfig)
    {
        
          // make a backup - just in case...
        std::string backupCommand = "cp ";
        backupCommand += notes_file;
        backupCommand += " ";
        backupCommand += notes_file;
        backupCommand += ".bak";   
        my_system(backupCommand.c_str());
    }
   
    conf->read_config(notes_file);
	conf->getNotesList(&noteConfigList);
	if ((noteConfigList)) {
		for (list=noteConfigList;list;list=list->tail) {
			note = new CNotes();
			n = (NoteStruct*)list->head;
			note->Set_Title(n->title);
			note->Set_FontName(n->fontName);
			note->Set_Transparent(n->transparent);
			note->Set_DesktopBackgd(n->desktopBackgd);
			note->Set_Shade(n->shade);
			note->Set_Angle(n->angle);
			note->Set_Sticky(n->sticky);
			note->Set_Ontop(n->ontop);
			note->Set_Alarm(n->alarm);
			note->Set_Border(n->border);
			note->Set_XPadding(n->paddingX);
			note->Set_YPadding(n->paddingY);
			note->Set_TextColor(n->textColor);
			note->Set_BackgdColor(n->backgdColor);
			note->Set_Text(n->text);
			note->Build_Note();
			notes = list_cons(note, notes);
			}
		DrawLed(GREEN);
		}
	else DrawLed(RED);
}

void write_config_file() {
	conf->setNotesList(notes);
	if (conf->save_config(notes_file)==-1) DrawLed(RED);
	else DrawLed(GREEN);
}

void open_config_window(CNotes *n){
struct stat buf;
char tempStr[1024];
int status,child;

	if (write_temp_config_file(n)!=-1) {
		stat(notes_temp_file,&buf);
		config_time = buf.st_mtime;
		child = waitpid(0,&status,WNOHANG);
		if (child!=0){
			sprintf(tempStr,"%s -f %s",config_program,notes_temp_file);
			my_system(tempStr);
			}
		}
	else config_time = 0;
}

//configure the default note
void open_default_config_window(){
struct stat buf;
NoteStruct *n;
char tempStr[1024];
int status,child;

	conf->getDefaultNote(&n);
	if (write_temp_default_config_file(n)!=-1) {
		stat(notes_temp_file,&buf);
		config_time = buf.st_mtime;
		child = waitpid(0,&status,WNOHANG);
		if (child!=0){
			sprintf(tempStr,"%s -f %s",config_program,notes_temp_file);
			my_system(tempStr);
			}
		}
	else config_time = 0;
}

void read_temp_config_file() {
CNotesConfig *conf_temp;
LinkedList *noteConfigList;
NoteStruct *n;

	conf_temp = new CNotesConfig();
	conf_temp->read_config(notes_temp_file);
	conf_temp->getNotesList(&noteConfigList);
	n = (NoteStruct*)noteConfigList->head;
	note_to_configure->Set_Title(n->title);
	note_to_configure->Set_FontName(n->fontName);
	note_to_configure->Set_Transparent(n->transparent);
	note_to_configure->Set_DesktopBackgd(n->desktopBackgd);
	note_to_configure->Set_Shade(n->shade);
	note_to_configure->Set_Angle(n->angle);
	note_to_configure->Set_Sticky(n->sticky);
	note_to_configure->Set_Ontop(n->ontop);
	note_to_configure->Set_Alarm(n->alarm);
	note_to_configure->Set_Border(n->border);
	note_to_configure->Set_XPadding(n->paddingX);
	note_to_configure->Set_YPadding(n->paddingY);
	note_to_configure->Set_TextColor(n->textColor);
	note_to_configure->Set_BackgdColor(n->backgdColor);
	note_to_configure->Set_Text(n->text);
	note_to_configure->Build_Note();
	delete conf_temp;

	write_config_file();
}

void read_temp_default_config_file() {
CNotesConfig *conf_temp;
LinkedList *noteConfigList;
NoteStruct *n;

	conf_temp = new CNotesConfig();
	conf_temp->read_config(notes_temp_file);
	conf_temp->getNotesList(&noteConfigList);
	n = (NoteStruct*)noteConfigList->head;
	conf->setDefaultNote(n);
	delete conf_temp;

	write_config_file();
}

int write_temp_config_file(CNotes *n) {
FILE *f;

	f = fopen(notes_temp_file,"w");

	if (f) {
		fprintf(f,"<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n\n");
		fprintf(f,"<ENotes>\n");
		fprintf(f,"\t<note border=\"%d\" angle=\"%d\" sticky=\"%d\" ontop=\"%d\" transparent=\"%d\" shade=\"%d\" desktopBackgd=\"%d\" paddingX=\"%d\" paddingY=\"%d\">\n",n->Get_Border(),n->Get_Angle(),n->Get_Sticky(),n->Get_Ontop(),n->Get_Transparent(),n->Get_Shade(),n->Get_DesktopBackgd(),n->Get_XPadding(),n->Get_YPadding());
		fprintf(f,"\t\t<alarm>%s</alarm>\n",n->Get_Alarm());
		fprintf(f,"\t\t<fontName>%s</fontName>\n",n->Get_FontName());
		fprintf(f,"\t\t<textColor>%s</textColor>\n",n->Get_TextColor());
		fprintf(f,"\t\t<backgdColor>%s</backgdColor>\n",n->Get_BackgdColor());
		fprintf(f,"\t\t<title>%s</title>\n",n->Get_Title());
		fprintf(f,"\t\t<text>%s</text>\n",n->Get_Text());
		fprintf(f,"\t</note>\n");
		fprintf(f,"</ENotes>\n");
		fclose(f);
		DrawLed(GREEN);
		return 0;
		}
	else {
		printf("could not write the file [%s], note cannot be configured!\n",notes_temp_file);
		DrawLed(RED);
		return -1;
		}
}

//write the temp file for the default note
int write_temp_default_config_file(NoteStruct *n) {
FILE *f;

	f = fopen(notes_temp_file,"w");

	if (f) {
		fprintf(f,"<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n\n");
		fprintf(f,"<ENotes>\n");
		fprintf(f,"\t<note border=\"%d\" angle=\"%d\" sticky=\"%d\" ontop=\"%d\" transparent=\"%d\" shade=\"%d\" desktopBackgd=\"%d\" paddingX=\"%d\" paddingY=\"%d\">\n",n->border,n->angle,n->sticky,n->ontop,n->transparent,n->shade,n->desktopBackgd,n->paddingX,n->paddingY);
		fprintf(f,"\t\t<alarm>%s</alarm>\n",n->alarm);
		fprintf(f,"\t\t<fontName>%s</fontName>\n",n->fontName);
		fprintf(f,"\t\t<textColor>%s</textColor>\n",n->textColor);
		fprintf(f,"\t\t<backgdColor>%s</backgdColor>\n",n->backgdColor);
		fprintf(f,"\t\t<title>%s</title>\n",n->title);
		fprintf(f,"\t\t<text>%s</text>\n",n->text);
		fprintf(f,"\t</note>\n");
		fprintf(f,"</ENotes>\n");
		fclose(f);
		DrawLed(GREEN);
		return 0;
		}
	else {
		printf("could not write the file [%s], default note cannot be configured!\n",notes_temp_file);
		DrawLed(RED);
		return -1;
		}
}

void create_note() {
CNotes *note;
NoteStruct *n;

	conf->getDefaultNote(&n);
	note = new CNotes();
		note->Set_Title(n->title);
		note->Set_FontName(n->fontName);
		note->Set_Transparent(n->transparent);
		note->Set_DesktopBackgd(n->desktopBackgd);
		note->Set_Shade(n->shade);
		note->Set_Angle(n->angle);
		note->Set_Sticky(n->sticky);
		note->Set_Ontop(n->ontop);
		note->Set_Alarm(n->alarm);
		note->Set_Border(n->border);
		note->Set_XPadding(n->paddingX);
		note->Set_YPadding(n->paddingY);
		note->Set_TextColor(n->textColor);
		note->Set_BackgdColor(n->backgdColor);
		note->Set_Text(n->text);
		note->Build_Note();
	notes = list_cons(note, notes);
}

/************************************************************\
|* usage																	   *|
\************************************************************/

void usage(void) {

	fprintf(stderr, "\nwmEnotes - programming: Philippe Vigneron\n\n");
	fprintf(stderr, "usage:\n");
	fprintf(stderr, "-config <configure program>  program used to configure the notes\n");
	fprintf(stderr, "-notes <notes file>          xml file where to store the notes\n");
	fprintf(stderr, "-temp <note temp file>       xml file where to store the temporary note info when configuring\n");
	fprintf(stderr, "-b                           backup the config file\n");
	fprintf(stderr, "-q                           query before deleting a note\n");
	fprintf(stderr, "-h                           this help screen\n");
	fprintf(stderr, "-v                           print the version number\n");
	fprintf(stderr, "\n");
}

/******************************************************************\
|* printversion																   *|
\******************************************************************/

void printversion(void) {

	fprintf(stderr, "%s\n", WMENOTES_VERSION);
}

/******************************************************************\
|* execute a command															   *|
\******************************************************************/

int my_system(const char *cmd) {
pid_t pid=0;
static pid_t oldpid=-1;
int err;

	pid = fork();
	if (pid!=0) {
		oldpid = pid;
		//printf("%d\n",oldpid);
		}
	if (pid) return -1;
	err = execl("/bin/sh", "/bin/sh", "-c", cmd, NULL);
	exit(0);

	return err;
}


/***************************************************************\
|* ButtonUp 																   *|
\***************************************************************/
void ButtonUp(int button) {

	switch (button) {
	case NEW_BUTTON :
		copyXPMArea(24, 74, 12, 11, 35, 48);
		break;
	case BUT_X :
		copyXPMArea(36, 74, 12, 11, 47, 48);
		break;
	}
	RedrawWindowXYWH(34,47,25,13);
}

/***************************************************************\
|* ButtonDown																   *|
\***************************************************************/
void ButtonDown(int button) {

	switch (button) {
	case NEW_BUTTON :
		copyXPMArea(0, 74, 12, 11, 35, 48);
		break;
	case BUT_X :
		copyXPMArea(12, 74, 12, 11, 47, 48);
		break;
	}
	RedrawWindowXYWH(34,47,25,13);
}

/***************************************************************\
|* ButtonDown																   *|
\***************************************************************/
void DrawLed(int led) {

	switch (led) {
	case GREEN :
		copyXPMArea(50, 80, 4, 4, 25, 49);
		copyXPMArea(50, 75, 4, 4, 25, 54);
		break;
	case RED :
		copyXPMArea(56, 75, 4, 4, 25, 54);
		copyXPMArea(50, 75, 4, 4, 25, 49);
		break;
	}
	RedrawWindowXYWH(23,47,8,13);
}


/***************************************************************\
|* DrawTime																	   *|
\***************************************************************/

void DrawNumberOfNotes(int i) {

	DrawNumber(i,6,COUNTER_DES_Y);
	RedrawWindowXYWH(6,COUNTER_DES_Y,15,7);
}

void DrawClock(int h, int m, int s) {

	//draws column between minutes and seconds
	// column
		copyXPMArea(62, TIMER_SRC_Y, 1, 7, 31, TIMER_DES_Y);
		copyXPMArea(62, TIMER_SRC_Y, 1, 7, 45, TIMER_DES_Y);
	//no column
//		copyXPMArea(63, TIMER_SRC_Y, 1, 7, 31, TIMER_DES_Y);
//		copyXPMArea(63, TIMER_SRC_Y, 1, 7, 45, TIMER_DES_Y);
	DrawNumber(h,19,TIMER_DES_Y);
	DrawNumber(m,33,TIMER_DES_Y);
	DrawNumber(s,47,TIMER_DES_Y);
	RedrawWindowXYWH(19,6,40,7);
}

void DrawNumber(int i,int x,int y) {

	int	k = 10;

	copyXPMArea(TIMER_SZE_X*((i / k)%10)+1, TIMER_SRC_Y, 5, 7, x, y);
	k = k /10;
	copyXPMArea(TIMER_SZE_X*((i / k)%10)+1, TIMER_SRC_Y, 5, 7, x+6, y);
}

