#include <X11/xpm.h>
#include <stdio.h>

extern "C" {
	#include "../wmgeneral/wmgeneral.h"
	#include "../wmgeneral/misc.h"
	#include "../wmgeneral/list.h"
}

#include "wmEnotes-mask.xpm"
#include "Notes.h"
#include "NotesConfig.h"
#include <sys/stat.h>
#include <sys/wait.h>
#include <sys/types.h>

#define NEW_BUTTON		(1)
#define BUT_X				(2)
#define TIMER_SRC_Y			(65)
#define TIMER_DES_Y			(6)
#define COUNTER_DES_Y		(50)
#define TIMER_SZE_X			(6)
#define WMENOTES_VERSION "0.6"
#define GREEN				(1)
#define RED					(2)

void printversion(void);
void usage(void);
int my_system(const char *cmd);
void ButtonUp(int button);
void ButtonDown(int button);
void wmEnotes_routine(int argc, char **argv);
void main_loop(void);
void notes_loop(void);
void create_note(void);
void read_config_file(void);
void write_config_file(void);
void DrawLed(int led);
void DrawNumberOfNotes(int i);
void DrawClock(int h,int m,int s);
void DrawNumber(int i,int x,int y);
int write_temp_config_file(CNotes *n);
int write_temp_default_config_file(NoteStruct *n);
void read_temp_config_file(void);
void read_temp_default_config_file(void);
void open_config_window(CNotes *n);
void open_default_config_window(void);
int IsConfigProgramRunning(const char *file);

typedef struct {
	int border;
	int angle;
	int sticky;
	int ontop;
	char alarm[128];
	int transparent;
	int desktopBackgd;
	int shade;
	int paddingX;
	int paddingY;
	char fontName[128];
	char textColor[16];
	char backgdColor[1024];
	char title[1024];
	char text[1024];
} DEFAULT_NOTE;
